(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

let compile ast =
  let ast = Optim.optimize ast in
  let ast = Compile_trace.compile_trace ast in
  let ast = Compile_forward.compile_forward ast in
  let ast = Compile_select.compile_select ast in
  let ast = Check_foreach.check_foreach ast in
  let ast = Compile_move.compile_move ast in
  let ast = Compile_ordering.compile_ordering ast in
  let ast = Compile_schedchild.compile_schedchild ast in
  let ast = Compile_time.compile_time ast in
  let ast = Compile_persistent.compile_persistent ast in
  let ast = Compile_misc.compile_misc ast in
  Post_verif.postprocess ast
