(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

type entry = Class_state.classname * Vobjects.vtype * Vobjects.modified

type type_rule = Objects.isquasi * entry list list * entry list list
type vs_type_rule =
    Objects.isquasi * (entry list * Class_state.classname list) list *
      entry list list

val pretty_print :
    string ->
      (Ast.event_name * type_rule list) list ->
	(Objects.identifier * type_rule list) list ->
	  (Objects.identifier * type_rule list) list ->
	    (Ast.event_name * (entry list) Model.sequence) list ->
	      (Ast.event_name * Quasi.intinfo * Quasi.required)
		Nfa2dfa.fa_state list ->
		  (Ast.event_name * Quasi.intinfo * Quasi.required)
		    Nfa2dfa.fa_state list ->
		      (Ast.event_name * vs_type_rule list) list
		      -> unit
