(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

type 'a sequence = START of 'a
  | TRANSITION of 'a sequence * Ast.event_name * 'a

type 'a ftres =
    NOTHING_NEW | NOT_FOUND | PREVTRANS of 'a sequence * 'a sequence list

val model : 'a list ->                       (* starting states *)
  ('a -> (Ast.event_name * 'a) list) ->      (* get_output_states *)
    (('a * Ast.event_name * 'a) -> ('a,'a sequence) Hashtbl.t ->
      'a ftres) ->
	('a,'a sequence) Hashtbl.t ->
	  ('a,'a sequence) Hashtbl.t ->
                                             (* find_transition *)
	    ('a -> unit) ->                  (* state printer function *)
	      ('a list * 'a sequence list)
