(*/////////////////////////////////////////////////////////////////////////////
//
// Bossa, a framework for scheduler programming
// Copyright (C) 2005 Ecole des Mines de Nantes and
// Department of Computer Science, University of Copenhagen
//
// This file is part of Bossa.
//
// Bossa is free software; you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation; either version 2.1 of the License, or
// any later version.
//
// Bossa is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with Bossa; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Please send remarks, questions and bug reports to bossa@emn.fr
// or to:
//
//   Gilles Muller
//   Ecole des Mines de Nantes,
//   La Chantrerie - 4, rue Alfred Kastler. B.P. 20722
//   44307 NANTES Cedex 3, FRANCE
//
///////////////////////////////////////////////////////////////////////////////
*)

type token =
  | MODULE
  | VSMODULE
  | MODULES
  | UNSHARED
  | REQUIRES
  | GLOBAL
  | SCHEDULER
  | TYPE
  | ENUM
  | PROCESS
  | CONST
  | ORDERING
  | LOWEST
  | HIGHEST
  | KEY
  | TRACE
  | STATES
  | READY
  | RUNNING
  | BLOCKED
  | TERMINATED
  | NOWHERE
  | QUEUE
  | FIFO
  | LIFO
  | HANDLER
  | EVENT
  | ON
  | INTERFACE
  | TRANSITION
  | DEFAULT
  | HIGHRES
  | LOWRES
  | BEFORE
  | AFTER
  | READS
  | OVERRIDEABLE
  | INT
  | BOOL
  | TIME
  | CYCLES
  | VOID
  | IF
  | ELSE
  | FOREACH
  | IN
  | SWITCH
  | RETURN
  | TIMER
  | PORT
  | HEAD
  | TAIL
  | FOREACHINC
  | FOREACHDEC
  | CASE
  | TRUE
  | FALSE
  | AND
  | OR
  | DOT
  | LPAREN
  | RPAREN
  | LCURLY
  | RCURLY
  | BREAK
  | DOT_DOT
  | LBRACK
  | RBRACK
  | EQUAL_EQUAL
  | NEQ
  | COMMA
  | SEMICOLON
  | COLON
  | EQL
  | PLUS
  | MINUS
  | TIMES
  | DIV
  | GT
  | LT
  | COMPLEMENT
  | LEQ
  | GEQ
  | EQUAL
  | RARROW
  | BITOR
  | BITAND
  | PLUS_PLUS
  | MINUS_MINUS
  | SELECT
  | EMPTY
  | NEXT
  | SRCONSCHED
  | SCHEDULEROF
  | PLUS_EQUAL
  | MINUS_EQUAL
  | TIMES_EQUAL
  | DIV_EQUAL
  | MOD_EQUAL
  | BITAND_EQUAL
  | BITOR_EQUAL
  | LSHIFT_EQUAL
  | RSHIFT_EQUAL
  | MOD
  | NOT
  | LSHIFT
  | RSHIFT
  | ERROR
  | EVENTS
  | TEST
  | EXPRESSIONS
  | FWD
  | VIRTSCHEDULER
  | DEFER
  | PUBLIC
  | PRIVATE
  | QUESTION
  | SYSTEM
  | STRUCT
  | ADMIT
  | ADMIT_CRIT
  | ADMIT_ATT
  | ADMIT_DET
  | EOF
  | INTEGER of (int)
  | IDENT of (string)
  | ENUM_TYPE of (string)
  | RANGE_TYPE of (string)
  | FN_NAME of (string)
  | STATE_NAME of (string)
  | MODULE_NAME of (string)
  | STRING of (string)

val module_spec :
  (Lexing.lexbuf  -> token) -> Lexing.lexbuf -> (Mast.super_sched * Objects.sched) * Objects.location
